/*******************************************************************************
 * Copyright (c) 2007, 2010 Association for Decentralized Information Management
 * in Industry THTH ry.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     VTT Technical Research Centre of Finland - initial API and implementation
 *******************************************************************************/
package org.simantics.db.tests.api.readGraph.adaptRelated;

import org.simantics.db.ReadGraph;
import org.simantics.db.Resource;
import org.simantics.db.WriteGraph;
import org.simantics.db.exception.DatabaseException;
import org.simantics.db.testing.base.WriteReadTest;
import org.simantics.db.tests.api.readGraph.common.Ontologies;

/**
 * Checks that {@link ReadGraph#adapt(org.simantics.db.Resource, Class)},
 * {@link ReadGraph#adaptUnique(org.simantics.db.Resource, Class)},
 * <code>AsyncReadGraph.forAdapted</code> fail as expected.
 * 
 * <p>
 * Regression test for https://www.simulationsite.net/trac/simantics/ticket/617
 * 
 * @author Tuukka Lehtonen
 */
public class AdaptRelatedTest2 extends WriteReadTest {
	private Resource instance;

	@Override
	protected void write(WriteGraph graph) throws DatabaseException {
        written = Ontologies.relatedConsiststOfString(L0, graph);
	}

	@Override
    protected void read(ReadGraph graph) throws DatabaseException {
		try {
			assertNotNull("Null not allowed", graph.adaptRelated(written, L0.ConsistsOf, String.class));
		} catch (Exception e) {
			fail("Exception: " + e.getClass().getCanonicalName());
		}
	}	
}
