/*******************************************************************************
 * Copyright (c) 2007, 2010 Association for Decentralized Information Management
 * in Industry THTH ry.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     VTT Technical Research Centre of Finland - initial API and implementation
 *******************************************************************************/
package org.simantics.db.tests.api.readGraph.getRelatedValue;

import org.simantics.db.ReadGraph;
import org.simantics.db.Resource;
import org.simantics.db.WriteGraph;
import org.simantics.db.exception.DatabaseException;
import org.simantics.db.exception.NoSingleResultException;
import org.simantics.db.testing.base.WriteReadTest;

public class GetRelatedValueTest7 extends WriteReadTest {
	private Float floatVal1 = 0.1F;
	private Float floatVal2 = 0.3F;

	private Resource instance1;
	private Resource instance2;

	private Resource type;
    @Override
    protected void write(WriteGraph graph) throws DatabaseException {
        instance1 = graph.newResource();
        instance2 = graph.newResource();
        type = graph.newResource();
        graph.claim(instance1, L0.InstanceOf, null,  L0.Float);
        graph.claim(instance2, L0.InstanceOf, null,  L0.Float);

        graph.claimValue(instance1, floatVal1);
        graph.claimValue(instance2, floatVal2);

        graph.claim(type, L0.ConsistsOf, instance1);
        graph.claim(type, L0.ConsistsOf, instance2);
    }
    
    @Override
    protected void read(ReadGraph graph) throws DatabaseException {
    	try {
            assertNotNull("Null response not allowed", graph.getRelatedValue(type, L0.ConsistsOf));
        } catch (NoSingleResultException e) {
        	return;
        } catch (Exception e) {
        	fail("Wrong exception: " + e.getClass().getCanonicalName());
        }
    	fail("Should throw.");
    }
}