/*******************************************************************************
 * Copyright (c) 2007, 2010 Association for Decentralized Information Management
 * in Industry THTH ry.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     VTT Technical Research Centre of Finland - initial API and implementation
 *******************************************************************************/
package org.simantics.db.tests.api.readGraph.isInheritedFrom;

import org.junit.Test;
import org.simantics.db.ReadGraph;
import org.simantics.db.common.request.ReadRequest;
import org.simantics.db.exception.DatabaseException;
import org.simantics.db.testing.base.SimpleBase;
import org.simantics.layer0.Layer0;
public class IsInheritedFromTest1 extends SimpleBase {
	@Test
    public void testInheritedFrom() throws DatabaseException {
        getSession().syncRequest(new ReadRequest() {
            @Override
            public void run(ReadGraph g) throws DatabaseException {
                Layer0 l0 = Layer0.getInstance(g);
//              g.isInheritedFrom(null, null);
//              g.isInheritedFrom(rl, null);
                assertTrue(g.isInheritedFrom(rl, rl));
                assertFalse(g.isInheritedFrom(rl, l0.Relation));
                assertFalse(g.isInheritedFrom(rl, l0.Entity));
                assertFalse(g.isInheritedFrom(rl, l0.Library));
                assertFalse(g.isInheritedFrom(rl, l0.Ontology));
                assertFalse(g.isInheritedFrom(rl, l0.Relation));
                assertTrue(g.isInheritedFrom(l0.Relation, l0.Relation));
                assertTrue(g.isInheritedFrom(l0.Relation, l0.Entity));
                assertTrue(g.isInheritedFrom(l0.Ontology, l0.Library));
                assertTrue(g.isInheritedFrom(l0.Ontology, l0.Entity));
                assertTrue(g.isInheritedFrom(l0.Library, l0.Entity));
            }
        });
    }
}