/*******************************************************************************
 * Copyright (c) 2007, 2010 Association for Decentralized Information Management
 * in Industry THTH ry.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     VTT Technical Research Centre of Finland - initial API and implementation
 *******************************************************************************/
package org.simantics.db.tests.api.readGraph.isSubrelationOf;

import org.junit.Test;
import org.simantics.db.ReadGraph;
import org.simantics.db.common.request.ReadRequest;
import org.simantics.db.exception.DatabaseException;
import org.simantics.db.testing.base.SimpleBase;
import org.simantics.layer0.Layer0;

public class IsSubrelationOfTest1 extends SimpleBase {
	@Test
    public void testSubrelationOf() throws DatabaseException {
        getSession().syncRequest(new ReadRequest() {
            @Override
            public void run(ReadGraph g) throws DatabaseException {
                Layer0 l0 = Layer0.getInstance(g);
                /*
                 * Null arguments are not allowed but are not checked. The
                 * behavior in this case is unspecified and can't be tested.
                 */
//                assertFalse(g.isSubrelationOf(null, null));
//                assertFalse(g.isSubrelationOf(rl, null));
                // Current implementation doesn't check if argument is relation.
                assertTrue(g.isSubrelationOf(rl, rl));
                // By definition returns true if the two resources are equal.
                assertTrue(g.isSubrelationOf(l0.Relation, l0.Relation));
                assertFalse(g.isSubrelationOf(rl, l0.Relation));
                assertFalse(g.isSubrelationOf(rl, l0.Entity));
                assertFalse(g.isSubrelationOf(rl, l0.Library));
                assertFalse(g.isSubrelationOf(l0.IsRelatedTo, l0.Relation));
                assertFalse(g.isSubrelationOf(l0.FunctionalRelation, l0.Relation));
                assertTrue(g.isSubrelationOf(l0.InverseOf, l0.DependsOn));
                assertTrue(g.isSubrelationOf(l0.InverseOf, l0.IsRelatedTo));
                assertTrue(g.isSubrelationOf(l0.InverseOf, l0.IsWeaklyRelatedTo));
                assertFalse(g.isSubrelationOf(l0.InverseOf, l0.Relation));
                assertFalse(g.isSubrelationOf(l0.InverseOf, l0.FunctionalRelation));
                assertFalse(g.isSubrelationOf(l0.InverseOf, l0.Relation));
                assertTrue(g.isSubrelationOf(l0.SubrelationOf, l0.DependsOn));
            }
        });
    }
}