package org.simantics.db.tests.api.write;

import org.junit.BeforeClass;
import org.junit.runner.RunWith;
import org.junit.runners.Suite.SuiteClasses;
import org.simantics.db.common.utils.Logger;
import org.simantics.db.testing.common.RegressionSuiteRunner;
import org.simantics.db.testing.common.Tests;
import org.simantics.db.tests.api.write.claim.WriteWithMultipleInverses;
import org.simantics.db.tests.api.write.claimLiteral.WriteUntypedCustomLiteral;
import org.simantics.db.tests.api.write.claimLiteral.WriteUntypedL0Literal;
import org.simantics.db.tests.api.write.claimValue.DataBlobTest;
import org.simantics.db.tests.api.write.claimValue.SetValueTest;
import org.simantics.db.tests.api.write.claimValue.SetValueTest2;
import org.simantics.db.tests.api.write.deny.DenyTest1;
import org.simantics.db.tests.api.write.denyValue.DenyValueTest;
import org.simantics.db.tests.api.write.request.SessionWriteErrorTest;
import org.simantics.db.tests.api.write.request.SessionWriteExceptionTest;
import org.simantics.db.tests.api.write.request.SessionWriteOnlyErrorTest;
import org.simantics.db.tests.api.write.request.WriteCallbackFailureTest;
import org.simantics.db.tests.api.write.request.WriteCancelTest;
import org.simantics.db.tests.api.write.request.WriteCancelTest2;
import org.simantics.db.tests.api.write.request.WriteGraphWriteExceptionTest;
import org.simantics.db.tests.api.write.request.WriteMetadataTest;
import org.simantics.db.tests.api.write.request.WriteOnlyReadTest;
import org.simantics.db.tests.api.write.story.AddStatementTest;
import org.simantics.db.tests.api.write.story.WriteIntoBuiltinResourceTest;

@RunWith(RegressionSuiteRunner.class)
@SuiteClasses({
	// claim
    WriteWithMultipleInverses.class,
	// claimLiteral
    WriteUntypedCustomLiteral.class,
    WriteUntypedL0Literal.class,
    // claimValue
    DataBlobTest.class,
    SetValueTest.class,
    SetValueTest2.class,
    // deny
    DenyTest1.class,
    // denyValue
    DenyValueTest.class,
    // request
    SessionWriteErrorTest.class,
    SessionWriteExceptionTest.class,
    SessionWriteOnlyErrorTest.class,
    WriteCallbackFailureTest.class,
    WriteCancelTest.class,
    WriteCancelTest2.class,
    WriteGraphWriteExceptionTest.class,
    WriteMetadataTest.class,
    WriteOnlyReadTest.class,
    // story
    AddStatementTest.class,
    WriteIntoBuiltinResourceTest.class
})
public class SuiteWrite {

	@BeforeClass
    public static void setUp() {
		try {
			Tests.freshDatabase();
		} catch (Exception e) {
			Logger.defaultLogError(e);
		}
    }

}
