/*******************************************************************************
 * Copyright (c) 2007, 2010 Association for Decentralized Information Management
 * in Industry THTH ry.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     VTT Technical Research Centre of Finland - initial API and implementation
 *******************************************************************************/
package org.simantics.db.tests.api.write.denyValue;

import org.junit.Test;
import org.simantics.databoard.Bindings;
import org.simantics.db.ReadGraph;
import org.simantics.db.Resource;
import org.simantics.db.WriteGraph;
import org.simantics.db.common.request.ReadRequest;
import org.simantics.db.common.request.WriteResultRequest;
import org.simantics.db.exception.DatabaseException;
import org.simantics.db.testing.annotation.Fails;
import org.simantics.db.testing.base.ExistingDatabaseTest;
import org.simantics.db.testing.common.WriteQuery;

public class DenyValueTest extends ExistingDatabaseTest {

	@Test
	@Fails
    public void test() throws Exception{

        final Resource r = getSession().syncRequest(new WriteResultRequest<Resource>() {
            @Override
            public Resource perform(WriteGraph g) throws DatabaseException {
                Resource f = g.newResource();
                g.claimValue(f, "A", Bindings.STRING);
                return f;

            }

        });

        getSession().syncRequest(new WriteQuery(this) {
            @Override
            public void run(WriteGraph g) throws Throwable {

                g.denyValue(r);

            }

        });

        getSession().syncRequest(new ReadRequest() {
            @Override
            public void run(ReadGraph g) throws DatabaseException {

                String value = g.getPossibleValue(r, Bindings.STRING);
                if(value != null) throw new AssertionError("Value was not removed!");

            }

        });

        checkException();

    }

}
