/*******************************************************************************
 * Copyright (c) 2007, 2010 Association for Decentralized Information Management
 * in Industry THTH ry.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     VTT Technical Research Centre of Finland - initial API and implementation
 *******************************************************************************/
package org.simantics.db.tests.suite;

import org.junit.BeforeClass;
import org.junit.runner.RunWith;
import org.junit.runners.Suite.SuiteClasses;
import org.simantics.db.common.utils.Logger;
import org.simantics.db.testing.common.RegressionSuiteRunner;
import org.simantics.db.testing.common.Tests;
import org.simantics.db.tests.api.SuiteAPI;
import org.simantics.db.tests.client.SuiteClient;
import org.simantics.db.tests.regression.SuiteRegression;

@RunWith(RegressionSuiteRunner.class)
@SuiteClasses({
    SuiteAPI.class,
    SuiteClient.class,
    SuiteRegression.class,
})
public class RegressionTests {
    @BeforeClass
    public static void setUp() {
        try {
            Tests.freshDatabase();
        } catch (Exception e) {
            Logger.defaultLogError(e);
        }
    }
}
